<?php

/*
 * This file is part of PHPExifTool.
 *
 * (c) 2012 Romain Neutron <imprec@gmail.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace PHPExiftool\Driver\Tag\CanonCustom;

use JMS\Serializer\Annotation\ExclusionPolicy;
use PHPExiftool\Driver\AbstractTag;

/**
 * @ExclusionPolicy("all")
 */
class SetButtonWhenShooting extends AbstractTag
{

    protected $Id = 'mixed';

    protected $Name = 'SetButtonWhenShooting';

    protected $FullName = 'mixed';

    protected $GroupName = 'CanonCustom';

    protected $g0 = 'MakerNotes';

    protected $g1 = 'CanonCustom';

    protected $g2 = 'Camera';

    protected $Type = 'mixed';

    protected $Writable = true;

    protected $Description = 'Set Button When Shooting';

    protected $flag_Permanent = true;

    protected $Values = array(
        0 => array(
            'Id' => 0,
            'Label' => 'Normal (disabled)',
        ),
        1 => array(
            'Id' => 1,
            'Label' => 'Image quality',
        ),
        2 => array(
            'Id' => 2,
            'Label' => 'Change parameters',
        ),
        3 => array(
            'Id' => 3,
            'Label' => 'Menu display',
        ),
        4 => array(
            'Id' => 4,
            'Label' => 'Image playback',
        ),
        5 => array(
            'Id' => 0,
            'Label' => 'Normal (disabled)',
        ),
        6 => array(
            'Id' => 1,
            'Label' => 'Image quality',
        ),
        7 => array(
            'Id' => 2,
            'Label' => 'Picture style',
        ),
        8 => array(
            'Id' => 3,
            'Label' => 'Menu display',
        ),
        9 => array(
            'Id' => 4,
            'Label' => 'Image playback',
        ),
        10 => array(
            'Id' => 5,
            'Label' => 'Quick control screen',
        ),
        11 => array(
            'Id' => 6,
            'Label' => 'Record movie (Live View)',
        ),
        12 => array(
            'Id' => 0,
            'Label' => 'Normal (disabled)',
        ),
        13 => array(
            'Id' => 1,
            'Label' => 'Image quality',
        ),
        14 => array(
            'Id' => 2,
            'Label' => 'Picture style',
        ),
        15 => array(
            'Id' => 3,
            'Label' => 'White balance',
        ),
        16 => array(
            'Id' => 4,
            'Label' => 'Flash exposure compensation',
        ),
        17 => array(
            'Id' => 5,
            'Label' => 'Viewfinder leveling gauge',
        ),
        18 => array(
            'Id' => 0,
            'Label' => 'Normal (disabled)',
        ),
        19 => array(
            'Id' => 1,
            'Label' => 'Image quality',
        ),
        20 => array(
            'Id' => 2,
            'Label' => 'Flash exposure compensation',
        ),
        21 => array(
            'Id' => 3,
            'Label' => 'LCD monitor On/Off',
        ),
        22 => array(
            'Id' => 4,
            'Label' => 'Menu display',
        ),
        23 => array(
            'Id' => 5,
            'Label' => 'ISO speed',
        ),
        24 => array(
            'Id' => 0,
            'Label' => 'Normal (disabled)',
        ),
        25 => array(
            'Id' => 1,
            'Label' => 'Image quality',
        ),
        26 => array(
            'Id' => 2,
            'Label' => 'Flash exposure compensation',
        ),
        27 => array(
            'Id' => 3,
            'Label' => 'LCD monitor On/Off',
        ),
        28 => array(
            'Id' => 4,
            'Label' => 'Menu display',
        ),
        29 => array(
            'Id' => 5,
            'Label' => 'Depth-of-field preview',
        ),
        30 => array(
            'Id' => 0,
            'Label' => 'LCD monitor On/Off',
        ),
        31 => array(
            'Id' => 1,
            'Label' => 'Image quality',
        ),
        32 => array(
            'Id' => 2,
            'Label' => 'Flash exposure compensation',
        ),
        33 => array(
            'Id' => 3,
            'Label' => 'Menu display',
        ),
        34 => array(
            'Id' => 4,
            'Label' => 'Disabled',
        ),
        35 => array(
            'Id' => 0,
            'Label' => 'Quick control screen',
        ),
        36 => array(
            'Id' => 1,
            'Label' => 'Image quality',
        ),
        37 => array(
            'Id' => 2,
            'Label' => 'Flash exposure compensation',
        ),
        38 => array(
            'Id' => 3,
            'Label' => 'LCD monitor On/Off',
        ),
        39 => array(
            'Id' => 4,
            'Label' => 'Menu display',
        ),
        40 => array(
            'Id' => 5,
            'Label' => 'Disabled',
        ),
        41 => array(
            'Id' => 0,
            'Label' => 'Normal (disabled)',
        ),
        42 => array(
            'Id' => 1,
            'Label' => 'White balance',
        ),
        43 => array(
            'Id' => 2,
            'Label' => 'Image size',
        ),
        44 => array(
            'Id' => 3,
            'Label' => 'ISO speed',
        ),
        45 => array(
            'Id' => 4,
            'Label' => 'Picture style',
        ),
        46 => array(
            'Id' => 5,
            'Label' => 'Record func. + media/folder',
        ),
        47 => array(
            'Id' => 6,
            'Label' => 'Menu display',
        ),
        48 => array(
            'Id' => 7,
            'Label' => 'Image playback',
        ),
        49 => array(
            'Id' => 0,
            'Label' => 'Default (no function)',
        ),
        50 => array(
            'Id' => 1,
            'Label' => 'Image quality',
        ),
        51 => array(
            'Id' => 2,
            'Label' => 'Change ISO speed',
        ),
        52 => array(
            'Id' => 3,
            'Label' => 'Change parameters',
        ),
    );

    protected $Index = 'mixed';

}
