<?php

/*
 * This file is part of PHPExifTool.
 *
 * (c) 2012 Romain Neutron <imprec@gmail.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace PHPExiftool\Driver\Tag\Sony;

use JMS\Serializer\Annotation\ExclusionPolicy;
use PHPExiftool\Driver\AbstractTag;

/**
 * @ExclusionPolicy("all")
 */
class AFPointSelected extends AbstractTag
{

    protected $Id = 'mixed';

    protected $Name = 'AFPointSelected';

    protected $FullName = 'mixed';

    protected $GroupName = 'Sony';

    protected $g0 = 'MakerNotes';

    protected $g1 = 'Sony';

    protected $g2 = 'Camera';

    protected $Type = 'mixed';

    protected $Writable = true;

    protected $Description = 'AF Point Selected';

    protected $flag_Permanent = true;

    protected $Values = array(
        0 => array(
            'Id' => 0,
            'Label' => 'Auto',
        ),
        1 => array(
            'Id' => 1,
            'Label' => 'Center',
        ),
        2 => array(
            'Id' => 2,
            'Label' => 'Top',
        ),
        3 => array(
            'Id' => 3,
            'Label' => 'Upper-right',
        ),
        4 => array(
            'Id' => 4,
            'Label' => 'Right',
        ),
        5 => array(
            'Id' => 5,
            'Label' => 'Lower-right',
        ),
        6 => array(
            'Id' => 6,
            'Label' => 'Bottom',
        ),
        7 => array(
            'Id' => 7,
            'Label' => 'Lower-left',
        ),
        8 => array(
            'Id' => 8,
            'Label' => 'Left',
        ),
        9 => array(
            'Id' => 9,
            'Label' => 'Upper-left',
        ),
        10 => array(
            'Id' => 10,
            'Label' => 'Far Right',
        ),
        11 => array(
            'Id' => 11,
            'Label' => 'Far Left',
        ),
        12 => array(
            'Id' => 12,
            'Label' => 'Upper-middle',
        ),
        13 => array(
            'Id' => 13,
            'Label' => 'Near Right',
        ),
        14 => array(
            'Id' => 14,
            'Label' => 'Lower-middle',
        ),
        15 => array(
            'Id' => 15,
            'Label' => 'Near Left',
        ),
        16 => array(
            'Id' => 1,
            'Label' => 'Center',
        ),
        17 => array(
            'Id' => 2,
            'Label' => 'Top',
        ),
        18 => array(
            'Id' => 3,
            'Label' => 'Top-Right',
        ),
        19 => array(
            'Id' => 4,
            'Label' => 'Right',
        ),
        20 => array(
            'Id' => 5,
            'Label' => 'Bottom-Right',
        ),
        21 => array(
            'Id' => 6,
            'Label' => 'Bottom',
        ),
        22 => array(
            'Id' => 7,
            'Label' => 'Bottom-Left',
        ),
        23 => array(
            'Id' => 8,
            'Label' => 'Left',
        ),
        24 => array(
            'Id' => 9,
            'Label' => 'Top-Left',
        ),
        25 => array(
            'Id' => 10,
            'Label' => 'Far Right',
        ),
        26 => array(
            'Id' => 11,
            'Label' => 'Far Left',
        ),
        27 => array(
            'Id' => 1,
            'Label' => 'Center',
        ),
        28 => array(
            'Id' => 2,
            'Label' => 'Top',
        ),
        29 => array(
            'Id' => 3,
            'Label' => 'Top-Right',
        ),
        30 => array(
            'Id' => 4,
            'Label' => 'Right',
        ),
        31 => array(
            'Id' => 5,
            'Label' => 'Bottom-Right',
        ),
        32 => array(
            'Id' => 6,
            'Label' => 'Bottom',
        ),
        33 => array(
            'Id' => 7,
            'Label' => 'Bottom-Left',
        ),
        34 => array(
            'Id' => 8,
            'Label' => 'Left',
        ),
        35 => array(
            'Id' => 9,
            'Label' => 'Top-Left',
        ),
        36 => array(
            'Id' => 0,
            'Label' => 'Auto',
        ),
        37 => array(
            'Id' => 1,
            'Label' => 'Center',
        ),
        38 => array(
            'Id' => 2,
            'Label' => 'Top',
        ),
        39 => array(
            'Id' => 3,
            'Label' => 'Upper-right',
        ),
        40 => array(
            'Id' => 4,
            'Label' => 'Right',
        ),
        41 => array(
            'Id' => 5,
            'Label' => 'Lower-right',
        ),
        42 => array(
            'Id' => 6,
            'Label' => 'Bottom',
        ),
        43 => array(
            'Id' => 7,
            'Label' => 'Lower-left',
        ),
        44 => array(
            'Id' => 8,
            'Label' => 'Left',
        ),
        45 => array(
            'Id' => 9,
            'Label' => 'Upper-left',
        ),
        46 => array(
            'Id' => 10,
            'Label' => 'Far Right',
        ),
        47 => array(
            'Id' => 11,
            'Label' => 'Far Left',
        ),
        48 => array(
            'Id' => 12,
            'Label' => 'Upper-middle',
        ),
        49 => array(
            'Id' => 13,
            'Label' => 'Near Right',
        ),
        50 => array(
            'Id' => 14,
            'Label' => 'Lower-middle',
        ),
        51 => array(
            'Id' => 15,
            'Label' => 'Near Left',
        ),
        52 => array(
            'Id' => 16,
            'Label' => 'Upper Far Right',
        ),
        53 => array(
            'Id' => 17,
            'Label' => 'Lower Far Right',
        ),
        54 => array(
            'Id' => 18,
            'Label' => 'Lower Far Left',
        ),
        55 => array(
            'Id' => 19,
            'Label' => 'Upper Far Left',
        ),
    );

}
